function [y, cy] = corrcoeff(x,n)
%function [y, cy] = corrcoeff(x,n)
%x: input matrix
%n: y length (<= x length)
%y: correlation coefficient
%cy: crosscorrelation coefficient among the first sequence and the others
[a,b]=size(x);
if (a<b), x=x.'; end
[l,m]=size(x);
for i=1:min(n,l)
   for j=1:m
  		pl1=x(1:l-i+1,j)';
      pl2=x(i:l,j).';
      y(j,i)=mean((pl1-mean(pl1)).*(pl2-mean(pl2)))./(var(pl1)*var(pl2))^0.5;
   end
end
if m==1
   cy=[];
else
   for i=1:min(n,l)
      for j=2:m
  			pl1=x(1:l-i+1,1)';
      	pl2=x(i:l,j).';
      	cy(j-1,i)=mean((pl1-mean(pl1)).*(pl2-mean(pl2)))./(var(pl1)*var(pl2))^0.5;   
      end
   end
end
