Nosc=64;         %Numero oscillatori
Nsig=4;          %numero segnali generati
Nsym=1e6;        %simboli generati per segnale
vm=30;          %velocit mobile km/h
v1=vm/3.6;       %m/s
cs=3e8;          %velocit luce nel vuoto
fc=1.8e9;         %frequenza portante
fd=v1/cs*fc;     %banda Doppler
dT=1e-4;         %intervallo di segnalazione
K=0;             %fattore di Rice
KdB=10*log10(K);
lcc=200;         %numero di elementi per il calcolo della correlazione
tmax=100*dT;     %grafico potenza tra 0 e tmax - primi 500 simboli
plot_correlation=1;
plot_pdf_power=1;
plot_pdf_components=1;
[rt,zt,rt1,rt2]=sosfadeli(Nsym,fd,dT,KdB,Nosc,Nsig);
figure;
if plot_correlation
    [y,cy]=corrcoeff(rt1,lcc);
    x=(0:(lcc-1))*fd*dT;
    subplot(2,2,1);
    stem(x(x<1),y(1,x<1),'k');
    hold on
    plot(x(x<1),(besselj(0,2*pi*x(x<1))).^1,'r')
    title('correlazione componente in fase');
end
if plot_pdf_power
    xp=0:.05:3;
    [cdf,yp]=ecdf2(xp,10.^(zt(1,:)/10));
    subplot(2,2,2);
    plot(xp,yp,'k')
    hold on
    yt=chi2(xp,1,K);
    plot(xp,yt,'r');
    title('PDF potenza ricevuta');
end
if plot_pdf_components
    xp=-3:.05:3;
    [cdf,yp]=ecdf2(xp,rt1(1,:));
    subplot(2,2,3);
    plot(xp,yp,'k')
    hold on
    [cdf,yp]=ecdf2(xp,rt2(1,:));
    plot(xp,yp,'k-.')
    legend('componente in fase','componente in quadratura');
    title('PDF componenti segnale ricevuto');
end

subplot(2,2,4);
t=(1:Nsym)*dT;
stem(t(t<=tmax),zt(1,t<=tmax),'k');
set(gca,'YLim',[-30,10]);
title('potenza ricevuta in dB primi simboli');
xlabel('t [s]');

hold on